'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _camelcase = require('camelcase');

var _camelcase2 = _interopRequireDefault(_camelcase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EVENTS = ['load-commit', 'did-finish-load', 'did-fail-load', 'did-frame-finish-load', 'did-start-loading', 'did-stop-loading', 'did-get-response-details', 'did-get-redirect-request', 'dom-ready', 'page-title-set', 'page-favicon-updated', 'enter-html-full-screen', 'leave-html-full-screen', 'console-message', 'new-window', 'close', 'ipc-message', 'crashed', 'gpu-crashed', 'plugin-crashed', 'destroyed'];

var HANDLERS = EVENTS.map(function (event) {
  return (0, _camelcase2.default)('on-' + event);
});

var EVENTS_HANDLERS = EVENTS.map(function (event, i) {
  return { event: event, handler: HANDLERS[i] };
});

function filterKeys(object, filterFunc) {
  return Object.keys(object).filter(filterFunc).reduce(function (filtered, key) {
    filtered[key] = object[key];
    return filtered;
  }, {});
}

var WebView = function (_React$Component) {
  _inherits(WebView, _React$Component);

  function WebView(props) {
    _classCallCheck(this, WebView);

    var _this = _possibleConstructorReturn(this, (WebView.__proto__ || Object.getPrototypeOf(WebView)).call(this, props));

    _this.state = { loaded: false, webview: null };
    return _this;
  }

  _createClass(WebView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // Set up listeners.
      var node = (0, _reactDom.findDOMNode)(this);

      this._bindEvents(node);
      this._assignMethods(node);
      this.setState({ loaded: true, webview: node });
    }
  }, {
    key: 'render',
    value: function render() {
      var tagProps = filterKeys(this.props, function (propName) {
        return !(propName in eventPropTypes);
      });
      return _react2.default.createElement('webview', tagProps);
    }

    // Private methods

  }, {
    key: '_bindEvents',
    value: function _bindEvents(node) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = EVENTS_HANDLERS[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _step$value = _step.value,
              event = _step$value.event,
              handler = _step$value.handler;

          node.addEventListener(event, this.props[handler]);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: '_assignMethods',
    value: function _assignMethods(node) {
      var _this2 = this;

      node.addEventListener('dom-ready', function () {
        Object.getOwnPropertyNames(node).filter(function (prop) {
          return typeof prop === 'function';
        }).forEach(function (method) {
          return _this2[method] = node[method];
        });
      });
    }
  }]);

  return WebView;
}(_react2.default.Component);

exports.default = WebView;


var tagPropTypes = {
  autosize: _react2.default.PropTypes.bool,
  disablewebsecurity: _react2.default.PropTypes.bool,
  httpreferrer: _react2.default.PropTypes.string,
  nodeintegration: _react2.default.PropTypes.bool,
  plugins: _react2.default.PropTypes.bool,
  preload: _react2.default.PropTypes.string,
  src: _react2.default.PropTypes.string,
  useragent: _react2.default.PropTypes.string,
  partition: _react2.default.PropTypes.string,
  allowpopups: _react2.default.PropTypes.bool,
  webpreferences: _react2.default.PropTypes.string,
  blinkfeatures: _react2.default.PropTypes.string,
  disableblinkfeatures: _react2.default.PropTypes.string,
  guestinstance: _react2.default.PropTypes.string
};

var eventPropTypes = EVENTS_HANDLERS.reduce(function (propTypes, _ref) {
  var event = _ref.event,
      handler = _ref.handler;

  propTypes[handler] = _react2.default.PropTypes.func;
  return propTypes;
}, {});

WebView.propTypes = Object.assign({}, tagPropTypes, eventPropTypes);
